<?php

namespace Drupal\asc_courses\Commands;

use Consolidation\OutputFormatters\StructuredData\RowsOfFields;
use Drush\Commands\DrushCommands;
use \Drupal\node\Entity\Node;

use \Drupal\asc_courses\AscCoursesApi;
use \Drupal\asc_courses\AscCoursesImporter;


/**
 * A Drush commandfile.
 *
 * In addition to this file, you need a drush.services.yml
 * in root of your module, and a composer.json file that provides the name
 * of the services file to use.
 *
 * See these files for an example of injecting Drupal services:
 *   - http://cgit.drupalcode.org/devel/tree/src/Commands/DevelCommands.php
 *   - http://cgit.drupalcode.org/devel/tree/drush.services.yml
 */
class AscCoursesCommands extends DrushCommands {

  public $soip_constant_name = "PANTHEON_SOIP_EIP";
  // public $soip_constant_name = "PANTHEON_SOIP_EIP_PROD";
  
  /**
   * Command description here.
   *
   * @param $arg1
   *   Argument description.
   * @param array $options
   *   An associative array of options whose values come from cli, aliases, config, etc.
   * @option option-name
   *   Description
   * @usage asc_courses-commandName foo
   *   Usage description
   *
   * @command asc_courses:commandName
   * @aliases foo
   */
  public function commandName($arg1, $options = ['option-name' => 'default']) {
    //$this->logger()->success(dt('Achievement unlocked.'));

    // $api = new AscCoursesApi();
    // print_r($api->fetchSubjectCourses('D0506'));

    // $api->getAccessToken();
    // $dorg = $api->config->get('asc_courses.dept_org');
    // echo "D-org: $dorg\n";
    // $courses = $api->fetchSubjectCourses($dorg);


    $importer = new AscCoursesImporter();
    $importer->fetchAndImportAll();
    // print_r($importer->loadSubjectDataFromDatabase('D0506'));
    
  }

  /**
   * Command description here.
   *
   * @param array $options
   *   An associative array of options whose values come from cli, aliases, config, etc.
   * @option option-name
   *   Description
   * @usage asc_courses-class-import
   *   Usage description
   *
   * @command asc_courses:class-import
   * @aliases asc-class-import
   */
  public function classImport($options = ['option-name' => 'default']) {
    // $this->logger()->success(dt('Achievement unlocked.'));

    // Bittrex example
    // $response = \Drupal::httpClient()
    // ->get('https://api.bittrex.com/api/v1.1/public/getmarkets');
    // $json_string = (string) $response->getBody();
    // $json_data = json_decode($json_string);
    // print_r($json_data);

    // return true;

    echo $this->soip_constant_name . ": " . constant($this->soip_constant_name) . "\n";
    

    $config = \Drupal::service('config.factory')->get('asc_courses.settings');
    $consumer_key = $config->get('asc_courses.qa_consumer_key');
    $consumer_secret = $config->get('asc_courses.qa_consumer_secret');
    $dept_org = $config->get('asc_courses.dept_org');
    $bearer_auth = base64_encode("$consumer_key:$consumer_secret");
    echo "consumer key: $consumer_key\n";
    echo "consumer secret: $consumer_secret\n";
    echo "dept_org: $dept_org\n";
    echo "bearer_auth: $bearer_auth\n";



    /*
      // get access token
      $token_response = \Drupal::httpClient()
        ->post($access_token_url, 
            [
              'headers' => [
                'Accept' => 'application/json',
                'Authorization' => "Basic $bearer_auth"
              ],
              'form_params' => [
                'grant_type' => 'client_credentials'
              ]
            ]
      );
      $json_string = (string) $token_response->getBody();
      $json_data = json_decode($json_string);
      print_r($json_data);
      $access_token = json_decode($token_response->getBody())->access_token;
      // echo "access_token: $access_token\n";
    */

    // QA URL
    $access_token_url = 'https://apig-qa.eip.osu.edu/token?grant_type=client_credentials';

    // Production URL
    // $access_token_url = 'https://apig.eip.osu.edu/token?grant_type=client_credentials';

    $access_token_headers = [
      "Accept: application/json",
      "Authorization: Basic $bearer_auth",
    ];

    // Create a "resolve_host" that will point to localhost and resolve externally
    $host = parse_url($access_token_url, PHP_URL_HOST);
    $localhost = "127.0.0.1";
    $resolve_host = array(sprintf("%s:%d:%s", $host, constant($this->soip_constant_name), $localhost));
    echo "\n resolve_host : " . implode($resolve_host) . "\n";

    // $post_data = ["grant_type" => "client_credentials"];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $access_token_url);
    curl_setopt($ch, CURLOPT_RESOLVE, $resolve_host);
    curl_setopt($ch, CURLOPT_PORT, constant($this->soip_constant_name));
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
    curl_setopt($ch, CURLOPT_POST, true);
    // curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
    curl_setopt($ch, CURLOPT_TIMEOUT, 30);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $access_token_headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
    curl_setopt($ch, CURLOPT_VERBOSE, true);
    $access_token_start = microtime(true);
    $access_token_result = curl_exec($ch);
    $access_token_error = curl_error($ch);
    print_r($access_token_error);
    curl_close($ch);
    $access_token_finish = microtime(true);
    $access_token_seconds = $access_token_finish - $access_token_start;

    echo "\n================\nAccess token result: \n";
    print_r($access_token_result);
    echo "\n";
    echo "Access token in $access_token_seconds seconds\n";


    $json_data = json_decode($access_token_result);
    // print_r($json_data);
    $access_token = $json_data->access_token;
    echo "access_token: $access_token\n\n";


    // QA URL
    $course_data_url = "https://apig-qa.eip.osu.edu/crseinfo/1.0.0/getCatalogInfo?campus=COL&acad_org=$dept_org";

    // Production URL
    // $course_data_url = "https://apig.eip.osu.edu/crseinfo/1.0.0/getCatalogInfo?campus=COL&acad_org=$dept_org";
    
    echo "course data url: $course_data_url\n";
    $course_data_headers = [
      "Accept: application/json",
      "Authorization: Bearer $access_token"
    ];


    /*
      // get course data  (httpClient)
      $response = \Drupal::httpClient()
      ->get("https://apig-qa.eip.osu.edu/crseinfo/1.0.0/getCatalogInfo?campus=COL&acad_org=$dept_org", 
              [
                // 'auth' => ['username', 'password'],
                'headers' => [
                  'Accept' => 'application/json',
                  'Authorization' => "Bearer $access_token"
                ]
              ]
      );
    
      $course_json = (string) $response->getBody();
      echo "json length: " . strlen($course_json) . "\n\n";
    */

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $course_data_url);
    curl_setopt($ch, CURLOPT_RESOLVE, $resolve_host);
    curl_setopt($ch, CURLOPT_PORT, constant($this->soip_constant_name));
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
    curl_setopt($ch, CURLOPT_TIMEOUT, 30);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $course_data_headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
    // curl_setopt($ch, CURLOPT_VERBOSE, true);
    $course_data_start = microtime(true);
    $course_data_result = curl_exec($ch);
    // print_r($course_data_result);
    $course_data_error = curl_error($ch);
    curl_close($ch);
    $course_data_finish = microtime(true);
    $course_data_seconds = $course_data_finish - $course_data_start;

    echo "Course data length:" . strlen($course_data_result) . "\n";
    echo "Course data in $course_data_seconds seconds\n\n";


    $connection = \Drupal::database();
    $row = [
      'date' => time(),
      'dept_org' => $dept_org,
      'raw_json' => $course_data_result
    ];
    $connection->insert('asc_course_data')->fields($row)->execute();


    $json_data = json_decode($course_data_result);

    // print_r($json_data);
  }

  /**
   * Command description here.
   *
   * @param array $options
   *   An associative array of options whose values come from cli, aliases, config, etc.
   * @option option-name
   *   Description
   * @usage asc_courses-create-courses
   *   Usage description
   *
   * @command asc_courses:create-courses
   * @aliases asc-create-courses
   */
  public function createCourses($options = ['option-name' => 'default']) {
    $connection = \Drupal::database();
    $course_info_query = $connection->select('asc_course_data', 'acd')
      // ->fields('acd', array('id', 'date', 'dept_org'))
      ->fields('acd')
      ->orderBy('date', 'DESC')
      ->range(0, 1);
    $course_info_result = $course_info_query->execute();
    // $result_count = $course_info_result->rowCount();
    // echo "Rows: $result_count\n";
    // $rows = $course_info_result->fetchAllAssoc('id', \PDO::FETCH_ASSOC);
    $row = $course_info_result->fetchAssoc();
    // print_r($row);
    $courses_json = $row['raw_json'];
    // $len = strlen($courses_json);
    echo "JSON Length:" . strlen($courses_json) . "\n";
    // echo substr($courses_json, 0, 1024) . "\n\n";
    $json_data = json_decode($courses_json);
    // print_r($json_data);
    
    foreach($json_data->getCourseCatalogResponse->catalog->course as $json_course) {
      if($i < 1) {
        print_r($json_course);

        // look up existing node
        $node_query = \Drupal::entityQuery('node')
          ->condition('field_eip_id', $json_course->{'crse-id'}, '=');
        $existing_node = $node_query->execute();

        if(empty($existing_node)) {
          // $course_node = Node::create([
          $course_node = \Drupal::entityTypeManager()->getStorage('node')->create(array(
            'type'        => 'course',
            'title'       => $json_course->{'course-title-long'},
            // 'field_course_description'  => $json_course->{'descrlong'},
            'field_course_number' => [$json_course->{'catalog-nbr'}],
            'field_credit_hours' => [$json_course->{'acad-prog'}],
            'field_subject_abbreviation' => [$json_course->{'subject'}],
            'field_eip_id'                => [$json_course->{'crse-id'}],
          ));
          $course_node->save();
          echo "New course [" . $json_course->{'catalog-nbr'} . "] ";
        }
        else {
          // update existing node
          echo "Update existing node!\n\n";
          print_r($existing_node);
        }

        // $i++;
      }
    }
  }

  /**
   * An example of the table output format.
   *
   * @param $nid
   *   ID of the node to be printed.
   * @param array $options An associative array of options whose values come from cli, aliases, config, etc.
   *
   * @field-labels
   *   group: Group
   *   token: Token
   *   name: Name
   * @default-fields group,token,name
   *
   * @command asc_courses:print-node
   * @aliases asc-print-node
   *
   * @filter-default-field name
   * @return \Consolidation\OutputFormatters\StructuredData\RowsOfFields
   */
  public function printNode($nid, $options = ['option-name' => 'default']) {
    $asdf_node = Node::load($nid);
    // print_r($asdf_node);

    $asdf_body = $asdf_node->get('body')->getValue();
    echo "body: " . print_r($asdf_body, true) . "\n";

    $asdf_desc = $asdf_node->get('field_course_description')->getValue();
    echo "description: " . print_r($asdf_desc, true) . "\n";

    $asdf_course_number = $asdf_node->get('field_course_number')->getValue();
    echo "course_number: " . print_r($asdf_course_number, true) . "\n";

    $asdf_credit_hours = $asdf_node->get('field_credit_hours')->getValue();
    echo "credit_hours: " . print_r($asdf_credit_hours, true) . "\n";

    // $asdf_eip_id = $asdf_node->get('field_eip_id')->getValue();
    // echo "eip_id: " . print_r($asdf_eip_id, true) . "\n";

    // $asdf_offered_autumn = $asdf_node->get('field_offered_autumn')->getValue();
    // echo "offered_autumn: " . print_r($asdf_offered_autumn, true) . "\n";

    // $asdf_offered_spring = $asdf_node->get('field_offered_spring')->getValue();
    // echo "offered_spring: " . print_r($asdf_offered_spring, true) . "\n";

    // $asdf_offered_summer = $asdf_node->get('field_offered_summer')->getValue();
    // echo "offered_summer: " . print_r($asdf_offered_summer, true) . "\n";

    // $asdf_subject_abbreviation = $asdf_node->get('field_subject_abbreviation'->getValue();
    // echo "subject_abbreviation: " . print_r($asdf_subject_abbreviation, true) . "\n";

    // $node_entity_type = \Drupal::entityTypeManager()->getDefinition('node');
    // $bundle_key = $node_entity_type = \Drupal::entityTypeManager()->getDefinition('node');
    // echo "bundle key: " . $bundle_key->getKey() . "\n";

  }

  /**
   * An example of the table output format.
   *
   * @param array $options An associative array of options whose values come from cli, aliases, config, etc.
   *
   * @field-labels
   *   group: Group
   *   token: Token
   *   name: Name
   * @default-fields group,token,name
   *
   * @command asc_courses:token
   * @aliases token
   *
   * @filter-default-field name
   * @return \Consolidation\OutputFormatters\StructuredData\RowsOfFields
   */
  public function token($options = ['format' => 'table']) {
    $all = \Drupal::token()->getInfo();
    foreach ($all['tokens'] as $group => $tokens) {
      foreach ($tokens as $key => $token) {
        $rows[] = [
          'group' => $group,
          'token' => $key,
          'name' => $token['name'],
        ];
      }
    }
    return new RowsOfFields($rows);
  }

}
